GroupAssignmentTwo/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf import settings

# import homepage.views as views
from register import views as v
from django.contrib.auth import views as auth_views
from django.conf.urls.static import static

urlpatterns = [
    path('admin/', admin.site.urls),
    # path('login/', auth_views.LoginView.as_view(template_name='login.html'), name='login'),
    # path('logout/', auth_views.LogoutView.as_view(), name='logout'),
    # path('signup/', views.signup, name='signup'),
    # path('settings/password/', views.settings, name='settings'),
    # path('oauth/', include('social_django.paths', namespace='social')),

    # path('register/', v.register, name='register'),
    # path('profile/', v.profile, name='profile'),
    # path('login/', auth_views.LoginView.as_view(template_name='register/login.html'), name='login'),
    # path('logout/', auth_views.LogoutView.as_view(template_name='register/logout.html'), name='logout'),

#    path('password-reset/',
#         auth_views.PasswordResetView.as_view(template_name='register/password_reset.html'),
#         name='password_reset'),

#     path('password-reset/done/',
#         auth_views.PasswordResetDoneView.as_view(template_name='register/password_reset_done.html'),
#         name='password_reset_done'),
    
#     path('password-reset-confirm/<uidb64>/<token>',
#         auth_views.PasswordResetConfirmView.as_view(template_name='register/password_reset_confirm.html'),
#         name='password_reset_confirm'),
    
#     path('password-reset-complete/',
#         auth_views.PasswordResetCompleteView.as_view(template_name='register/password_reset_complete.html'),
#         name='password_reset_complete'),
    path('',include('homepage.urls')),
    path('cart/', include('cart.urls')),
    path('product/', include('products.urls')),
    path('buy/', include('transaction.urls')),
    path('register/', v.register, name='register'),
    path('profile/', v.profile, name='profile'),
    path('review/', include('review.urls')),
    path('login/', auth_views.LoginView.as_view(template_name='register/login.html'), name='login'),
    path('logout/', auth_views.LogoutView.as_view(template_name='register/logout.html'), name='logout'),

    #Password Reset
    path('password-reset/',
        auth_views.PasswordResetView.as_view(template_name='register/password_reset.html'),
        name='password_reset'),

    path('password-reset/done/',
        auth_views.PasswordResetDoneView.as_view(template_name='register/password_reset_done.html'),
        name='password_reset_done'),
    
    path('password-reset-confirm/<uidb64>/<token>',
        auth_views.PasswordResetConfirmView.as_view(template_name='register/password_reset_confirm.html'),
        name="password_reset_confirm"),
    
    path('password-reset-complete/',
        auth_views.PasswordResetCompleteView.as_view(template_name='register/password_reset_complete.html'),
        name='password_reset_complete'),
    
    #Google Login
    path('accounts/', include('allauth.urls')),
] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

cart/urls.py
from django.urls import path, include
from . import views

app_name = 'ShoppingCart'

urlpatterns = [
    path('', views.CartView),
    path('json/', views.Json_Response),
]

transaction/urls.py
from django.urls import path, include
from django.conf.urls import url
from . import views

app_name = 'transaction'

urlpatterns = [
    path('', views.index, name='index'),
    path('API/getcoupons', views.getcoupon, name='getcoupon'),
    path('API/pay', views.pay, name='pay')
]

transaction/models.py
from django.db import models
from cart.models import Order
from register.models import Profile

# Create your models here.
class CouponCut(models.Model):
    name = models.CharField(max_length=15)
    couponcode = models.CharField(max_length=15)
    discount = models.FloatField()

class History(models.Model):
    user = models.ForeignKey(Profile, on_delete=models.CASCADE)
    order = models.ForeignKey(Order, on_delete=models.CASCADE)
    coupon = models.ForeignKey(CouponCut, on_delete=models.SET_NULL, null=True, blank=True)
    totalprice = models.IntegerField()
    address = models.TextField()
    order_date = models.DateTimeField(auto_now_add=True)

transaction/forms.py
from django import forms
from .models import History

class addHistory(forms.ModelForm):
    class Meta:
        model = History
        fields = {
            'order',
            'coupon',
            'address',
            'totalprice'
        }

transaction/views.py
from django.shortcuts import render, redirect, get_object_or_404
from django.contrib import messages
from django.core import validators, serializers
from django.urls import reverse
from django.http import JsonResponse
from django.http import HttpResponse
import json

from cart.models import Order, OrderItem
from products.models import Product
from register.models import Profile
from .models import CouponCut, History
from .forms import addHistory

# Create your views here.
def index(request):
    context = {}
    if request.method == 'GET':
        try:
            items = Order.objects.get(ref_code=request.GET.get('ref_code')).items.all()
        except Order.DoesNotExist:
            return redirect('')
        totalprice = 0
        for OrderedItem in items:
            totalprice += OrderedItem.product.price
        
        context["items"] = items
        context['totalprice'] = totalprice
        context['ref_code'] = request.GET.get('ref_code')
    
    return render(request, 'checkout.html', context)

def getcoupon(request):
    if request.is_ajax and request.method == 'GET':
        coupon = CouponCut.objects.get(couponcode=request.GET.get('couponcode'))
        obj = serializers.serialize('json', [coupon, ])
        return JsonResponse({"response": obj}, status=200)

    return JsonResponse({"error": "Wrong Access"}, status=400)

def pay(request):
    if request.is_ajax and request.method == 'POST':
        order = Order.objects.get(ref_code=request.POST.get('ref_code'))
        try:
            coupon = CouponCut.objects.get(couponcode=request.POST.get('couponcode'))
            totalprice = request.POST.get('totalprice') * (1-coupon.discount)
        except:
            coupon = None
            totalprice = request.POST. get('totalprice')
        
        data = {
            'order': order,
            'coupon': coupon,
            'address': request.POST.get('address'),
            'totalprice': totalprice
        }
        form = addHistory(data)

        print(form.is_valid())
        print(data)
        if form.is_valid():
            form.save()
            return JsonResponse({"success": "Payment Successful"}, status=200)
        else:
            return JsonResponse({"error": "Invalid Form"}, status=400)

    return JsonResponse({"error": "Wrong Access"}, status=400)

def history(request):
    if request.method == 'GET':
        user_profile = get_object_or_404(Profile, user=request.user)
        history = History.objects.filter(user=user_profile)

        context = {
            'history': history,
        }

        return render(request, 'history.html', context)

transaction/templates/base.html
<!doctype html>
{% load static %}
<html lang="en">

  <head>

    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

    <!-- Bootstrap CSS -->
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/css/bootstrap.min.css" integrity="sha384-Vkoo8x4CGsO3+Hhxv8T/Q5PaXtkKtu6ug5TOeNV6gBiFeWPGFN9MuhOf23Q9Ifjh" crossorigin="anonymous">
    
    <!-- Home CSS -->
    <link rel="stylesheet" href="{% static 'cart/style.css' %}">

    <!-- Font Link -->
    <link href="https://fonts.googleapis.com/css?family=Oswald|Playfair+Display&display=swap" rel="stylesheet">


    <title>stackovershoes</title>

  </head>
  
  <body>

    <nav class="navbar navbar-expand-lg navbar-dark bg-dark sticky-top">
      <div class="container">
        <a class="navbar-brand" href="/">
          <img src="{% static 'cart/stackovershoes-logo-white.png' %}" width="40" height="40" alt="">
        </a>
        <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarTogglerDemo02" aria-controls="navbarTogglerDemo02" aria-expanded="false" aria-label="Toggle navigation">
          <span class="navbar-toggler-icon"></span>
        </button>
        <form class="form-inline my-2 my-lg-0">
          <input class="form-control mr-sm-2 nav-font" type="search" placeholder="Search">
        </form>
        <div class="collapse navbar-collapse" id="navbarTogglerDemo02">
          <ul class="navbar-nav ml-auto">
            <li class="nav-item active">
              <a class="nav-link nav-font" href="/category"><b>CATEGORY</b></a>
            </li>

            {% if user.is_authenticated %}
            <li class="nav-item active">
              <a class="nav-link nav-font" href="/buy"><b>CART</b></a>
            </li>
            <li class="nav-item active">
              <a class="nav-link nav-font" href="/vouchers"><b>VOUCHERS</b></a>
            </li>
            <li class="nav-item active">
              <a class="nav-link nav-font" href="/history"><b>HISTORY</b></a>
            </li>
            <li class="nav-item active dropdown">
                <a class="nav-link dropdown-toggle nav-font" href="#" id="navbarDropdown" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" style="text-transform: uppercase;">
                  {{ user.username }}
                </a>
                <div class="dropdown-menu" aria-labelledby="navbarDropdown">
                  <a class="dropdown-item" href="/profile">PROFILE</a>
                  <div class="dropdown-divider"></div>
                  <a class="dropdown-item" href="/logout">LOGOUT</a>
                </div>
              </li>

            {% else %}
            <li class="nav-item active">
                <a class="nav-link nav-font" href="/login"><b>SIGN IN</b></a> 
              </li>
              <li class="nav-item active">
                <a class="nav-link nav-font" href="/register"><b>REGISTER</b></a>
              </li>
            {% endif %}
          </ul>  
        </div>
      </div>
    </nav>

    {% if messages %}
      {% for message in messages %}
        <div class="alert alert-{{ message.tags}}">
          {{ message }}
        </div>
      {% endfor %}
    {% endif %}

{% block content %}{% endblock %}

    <!-- Optional JavaScript -->
    <!-- jQuery first, then Popper.js, then Bootstrap JS -->
    <!-- <script src="https://code.jquery.com/jquery-3.4.1.slim.min.js" integrity="sha384-J6qa4849blE2+poT4WnyKhv5vZF5SrPo0iEjwBvKU7imGFAV0wwj1yYfoRSJoZ+n" crossorigin="anonymous"></script> -->
    <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.0/dist/umd/popper.min.js" integrity="sha384-Q6E9RHvbIyZFJoft+2mJbHaEWldlvI9IOYy5n3zV9zzTtmI3UksdQRVvoxMfooAo" crossorigin="anonymous"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/js/bootstrap.min.js" integrity="sha384-wfSDF2E50Y2D1uUdj0O3uMBJnjuUD4Ih7YwaYd1iqfktj0Uod8GCExl3Og8ifwB6" crossorigin="anonymous"></script>

</html>

transaction/templates/checkout.html
{% extends 'base.html'%}
{% block content %}
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.1.0/jquery.min.js"></script>
<style>
    #result {
       position: absolute;
       width: 100%;
       max-width:250px;
       cursor: pointer;
       overflow-y: auto;
       max-height: 400px;
       box-sizing: border-box;
       z-index: 1001;
    }
    .link-class:hover{
     background-color:#f1f1f1;
    }
</style>
<div class="container">

    <div class="bg-light rounded-pill px-4 py-3 text-uppercase font-weight-bold">Order summary </div>
          <div class="p-4">
            <ul class="list-unstyled mb-4">

                <table class="table">
                  <thead>
                    <tr>
                      <th scope="col">#</th>
                      <th scope="col">Item Name</th>
                      <th scope="col">Amount</th>
                      <th scope="col">Price</th>
                      <th scope="col">Total</th>
                    </tr>
                  </thead>
                  
                  <tbody class="items">
                    {% for item in items %}
                    <tr>
                      <th scope="row" class="itemsIndex"></th>
                      <td>{{ item.product.name }}</td>
                      <td>{{ item.ammount }}</td>
                      <td>{{ item.product.price }}</td>
                      <td class="itemsTotalPrice"></td>
                    </tr>
                    {% endfor %}
                  </tbody>
                </table>
                  


              <li class="d-flex justify-content-between py-3 border-bottom"><strong class="text-muted">Total</strong>
                <h5 class="font-weight-bold totalprice">{{ totalprice }}</h5>
              </li>
              <br>
              <div class="row">
                <div class="col-8">
                    <div align="center">
                        <input type="text" id="submitaddress" placeholder="Add your shipping address" class="form-control" />
                    </div>      
                </div>
                <div class="col-4">
                    <input class="btn btn-dark" type="submit" name="submit" id="submitaddressbtn" value="Submit Address">
                </div>
            </div>
            <br>
                <div class="row">
                    <div class="col-8">
                        <div align="center">
                            <input type="text" name="search" id="searchcoupon" placeholder="Search Coupons" class="form-control">
                        </div>      
                        <ul class="list-group" id="result"></ul>
                    </div>
                    <div class="col-4">
                        <input class="btn btn-dark applycoupon" type="submit" name="submit" id="applycoupon" value="Apply">
                    </div>
                    <br>
                </div>

                </ul>
                <form id="pay" action="POST">
                  {% csrf_token %}
                  <input type="hidden" name="ref_code" value={{ref_code}}>
                  <input type="hidden" name="totalprice" value={{totalprice}}>
                  <button class="btn-pay btn btn-dark rounded-pill py-2 btn-block">PAY</button>
                </form>
            </div>

    </div>

    <script>
        $(document).ready(function(){
         $.ajaxSetup({ cache: false });
         $('#searchcoupon').keyup(function(){
          $('#result').html('');
          $('#state').val('');
          var searchField = $('#searchcoupon').val();
          var expression = new RegExp(searchField, "i");
          $.getJSON('/static/data.json', function(data) {
           $.each(data, function(key, value){
            if (value.name.search(expression) != -1 || value.couponcode.search(expression) != -1)
            {
             $('#result').append('<li class="list-group-item">'+value.name+' | <span class="text-muted">'+value.couponcode+'</span></li>');
            }
           });   
          });
         });
         
         $('#result').on('click', 'li', function() {
          var click_text = $(this).text().split('|');
          $('#searchcoupon').val($.trim(click_text[1]));
          $("#result").html('');
         });
        });
        </script>
      {% include 'coupon.html' %}
      {% include 'pay.html' %}
</div>


{%endblock%}

transaction/templates/coupon.html
<script>
    $(".applycoupon").on('click', function() {
        var couponcode = $('#searchcoupon').val();

        $.ajax({
            type: 'GET',
            url: "{% url 'transaction:getcoupon' %}",
            data: {
                'couponcode': couponcode,
            },
            success: function(response) {
                var coupon = JSON.parse(response["response"])[0]['fields']['discount']

                var totalprice = $("input[name='totalprice'").val()
                totalprice = totalprice * (1-coupon)
                $(".totalprice").text(totalprice.toString(10))

                var input = `
                <input type="hidden" name="couponcode" value="${couponcode}">
                `
                
                $("#pay").append(input)
                alert("Coupon added!")
            }
        })
        .fail  (function(jqXHR, textStatus, errorThrown) { alert("Error")   ; })
    })

    $("#submitaddressbtn").on('click', function() {
        var address = $("#submitaddress").val()

        console.log(address)
        var input = `
            <input type="hidden" name="address" value="${address}">
        `

        $("#pay").append(input)
        alert("Submit Address Successful!")
    })
</script>

transaction/templates/history.html
{% extends 'base.html'%}
{% block content %}

<div class="container">

    <div class="bg-light rounded-pill px-4 py-3 text-uppercase font-weight-bold">Transaction History</div>
          <div class="p-4">
            <ul class="list-unstyled mb-4">
                <table class="table">
                    <thead>
                      <tr>
                        <th scope="col">#</th>
                        <th scope="col">Date ordered</th>
                        <th scope="col">Ref Code</th>
                        <th scope="col">Total Price</th>
                        <th scope="col">Address</th>
                      </tr>
                    </thead>
                    <tbody>
                      {% for order in history %}
                      <tr>
                        <th scope="row"></th>
                        <td>{{order.order.ref_code}}</td>
                        <td>{{order.order_date}}</td>
                        <td>{{order.totalprice}}</td>
                        <td>{{order.address}}</td>
                      </tr>
                      {% endfor %}
                    </tbody>
                  </table>
            </div>
    </div>


{%endblock%}

transaction/templates/pay.html
<script>
    $("html").on('click', ".btn-pay", function(e) {
        e.preventDefault()
        var form = $("#pay")

        var data = {}
        jQuery.each($(form).serializeArray(), function(i, field) {
            data[field.name] = field.value
        })

        if(data['address'] == null) {
            alert("Address must be Inputted!")
            return
        }

        $.ajax({
            type: 'POST',
            url: "{% url 'transaction:pay' %}",
            data: data,
            success: function(response) {
                alert("Payment is Successful")
                window.location.href = "{% url 'transaction:pay' %}";
            }
        })
        .fail  (function(jqXHR, textStatus, errorThrown) { alert("Error")})
    })
</script>